package pl.edu.uw;

import pl.edu.uw.optional.Storage;
import pl.edu.uw.optional.SingleElementStorage;
import pl.edu.uw.vector.MyInteger;
import pl.edu.uw.vector.Vector;

import java.util.Optional;

public class Main {

    public static void main(String[] args) {
//        TODO 2
//        vectorTest();
//        optionalTest();
    }

    private static void vectorTest() {
        Vector<MyInteger> v1 = new Vector<>(MyInteger.class, 10);
        Vector<MyInteger> v2 = new Vector<>(10);
        for (int i = 0; i < 10; i++) {
            v1.setValue(i, new MyInteger(i));
            v2.setValue(i, new MyInteger(i * 2));
        }
        Vector<MyInteger> v3 = v1.sum(v2);
        for (int i = 0; i < 10; i++) {
            System.out.println(v3.getValue(i));
        }
    }

    private static void optionalTest() {
        Storage<Integer, String> storage = new SingleElementStorage<>();
        storage.put(1, "jeden");
        storage.get(1).ifPresent(System.out::println);
        storage.put(3, "trzytrzytrzy");
        Optional<String> maybeValue = storage.get(2)
                .or(() -> storage.get(3))
                .or(() -> storage.get(4));
        if (maybeValue.isPresent()) {
            System.out.println(maybeValue.get());
        } else {
            System.out.println("Nie znaleziono wartości");
        }
        maybeValue.ifPresentOrElse(
                System.out::println,
                () -> System.out.println("Nie znaleziono wartości"));
        maybeValue
                .map(String::length)
                .filter(i -> i > 5)
                .ifPresentOrElse(
                        i -> System.out.println("Napis jest dłuższy niż 5, jego długość to: " + i),
                        () -> System.out.println("Napis jest krótszy niż 5 lub go w ogóle nie ma")
                );
        String value = maybeValue.orElseThrow();
        System.out.println("Teraz albo mamy napis, albo rzuciliśmy wyjątek. Napis to: " + value);
    }
}
