package pl.edu.uw.pair;

public class Pair<T, Q> {

    private final T first;
    private final Q second;

    public Pair(T first, Q second) {
        this.first = first;
        this.second = second;
    }

    public T getFirst() {
        return first;
    }

    public Q getSecond() {
        return second;
    }

    @Override
    public boolean equals(Object o) {
        if (!(o instanceof Pair<?, ?>)) return false;
        Pair<T, Q> p = (Pair<T, Q>) o;  // Ostrzeżenie kompilatora: unchecked cast
        if ((getFirst() != null) && (getSecond() != null)) {
            return getFirst().equals(p.getFirst()) && getSecond().equals(p.getSecond());
        } else if ((getFirst() == null) && (getSecond() == null)) {
            return (p.getFirst() == null) && (p.getSecond() == null);
        } else { // dokładnie jeden z elementów pary jest równy null
            if (getFirst() == null) {
                return (p.getFirst() == null) && (getSecond().equals(p.getSecond()));
            } else { // drugi()==null
                return getFirst().equals(p.getFirst()) && (p.getSecond() == null);
            }
        }
    }
}
